unit EdenUnit;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, ComCtrls, StdCtrls, ExtCtrls, Spin, IniFiles, Global;

type
  TRule=set of 0..8;
//  TCellNumbers = 0..255;
//  TGenSet = set of TCellNumbers;
  TState = (sOFF, sON, sUNK, sNone);
  TCell=record
    x,y     : longint;
    b       : byte;
    s       : TState;
  end;
  TPolePoint = array [0..1] of Integer;
  TForm1 = class(TForm)
    Pole: TDrawGrid;
    btClear: TButton;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    seOdds: TSpinEdit;
    PaintBox1: TPaintBox;
    Timer1: TTimer;
    cbAutoCorr: TCheckBox;
    cbRandCorr: TCheckBox;
    btStart: TButton;
    seFrom: TSpinEdit;
    Label14: TLabel;
    Label15: TLabel;
    Timer2: TTimer;
    cbAutoCalc: TCheckBox;
    Label16: TLabel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    edFactor: TEdit;
    edAddMember: TEdit;
    seBlunder: TSpinEdit;
    Label20: TLabel;
    procedure PoleDrawCell(Sender: TObject; ACol, ARow: Integer;
      Rect: TRect; State: TGridDrawState);
    procedure FormCreate(Sender: TObject);
    procedure PoleMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure btClearClick(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure btStartClick(Sender: TObject);
    procedure seOddsExit(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure cbRandCorrClick(Sender: TObject);
    procedure seFromExit(Sender: TObject);
    procedure edAddMemberKeyPress(Sender: TObject; var Key: Char);
    procedure edFactorKeyPress(Sender: TObject; var Key: Char);
    procedure edFactorExit(Sender: TObject);
    procedure edAddMemberExit(Sender: TObject);
  private
    procedure SetRecommendedColor(State: TState);
    function LogString: String;
    procedure ReadIni;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses FArray;

{$R *.DFM}
Const
  SRule   : TRule      = [2,3];
  BRule   : TRule      = [3];
  StateColors: array [TState] of TColor =(clWhite,clOlive,clSilver,clDkGray);
  CellSequence: array [0..195] of TPolePoint =
    ((21,21), (22,21), (22,20), (21,20), (20,20), (20,21), (20,22),
     (21,22), (22,22), (23,22), (23,21), (23,20), (23,19), (22,19),
     (21,19), (20,19), (19,19), (19,20), (19,21), (19,22), (19,23),
     (20,23), (21,23), (22,23), (23,23), (24,23), (24,22), (24,21),
     (24,20), (24,19), (24,18), (23,18), (22,18), (21,18), (20,18),
     (19,18), (18,18), (18,19), (18,20), (18,21), (18,22), (18,23),
     (18,24), (19,24), (20,24), (21,24), (22,24), (23,24), (24,24),
     (25,24), (25,23), (25,22), (25,21), (25,20), (25,19), (25,18),
     (25,17), (24,17), (23,17), (22,17), (21,17), (20,17), (19,17),
     (18,17), (17,17), (17,18), (17,19), (17,20), (17,21), (17,22),
     (17,23), (17,24), (17,25), (18,25), (19,25), (20,25), (21,25),
     (22,25), (23,25), (24,25), (25,25), (26,25), (26,24), (26,23),
     (26,22), (26,21), (26,20), (26,19), (26,18), (26,17), (26,16),
     (25,16), (24,16), (23,16), (22,16), (21,16), (20,16), (19,16),
     (18,16), (17,16), (16,16), (16,17), (16,18), (16,19), (16,20),
     (16,21), (16,22), (16,23), (16,24), (16,25), (16,26), (17,26),
     (18,26), (19,26), (20,26), (21,26), (22,26), (23,26), (24,26),
     (25,26), (26,26), (27,26), (27,25), (27,24), (27,23), (27,22),
     (27,21), (27,20), (27,19), (27,18), (27,17), (27,16), (27,15),
     (26,15), (25,15), (24,15), (23,15), (22,15), (21,15), (20,15),
     (19,15), (18,15), (17,15), (16,15), (15,15), (15,16), (15,17),
     (15,18), (15,19), (15,20), (15,21), (15,22), (15,23), (15,24),
     (15,25), (15,26), (15,27), (16,27), (17,27), (18,27), (19,27),
     (20,27), (21,27), (22,27), (23,27), (24,27), (25,27), (26,27),
     (27,27), (28,27), (28,26), (28,25), (28,24), (28,23), (28,22),
     (28,21), (28,20), (28,19), (28,18), (28,17), (28,16), (28,15),
     (28,14), (27,14), (26,14), (25,14), (24,14), (23,14), (22,14),
     (21,14), (20,14), (19,14), (18,14), (17,14), (16,14), (15,14));
  HexaCode: array [0..15] of Char =
    ('0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F');
//  LogFileName = 'Results.log';
//  ParentsCountLimit = 1 shl 24;
var
  Gen1     : array [TCellNumbers] of TCell;
  Gen1ONSet: TGenSet;
  Gen1ONSetB: array [0..31] of Byte absolute Gen1ONSet;
  Gen1NoUNKSet: TGenSet;
  Gen0Set: TGenSet;
  OkrSet: TGenSet;
  Okr0Vars: array [0..511] of TGenSet;
  Okr0Count: integer;
  a:array[0..41,0..41] of TState;
  okri     : array[1..9] of TCellNumbers;
  n1ON,n1OFF,n0: integer;
  mo: Integer;
  WasWarning: Boolean;
  ParentsCount, AltCount: Int64;
  StopAutoCalc: Boolean;
//  ParentsCountLimit: Int64;
  LogFileName: String;
  LimFactor: Double;
  LimAddMember: Integer;
  MinParents, CurParents: array [0..195] of Int64;

procedure ClrCol;
 var i,j      : integer;
begin
 StopAutoCalc := True;
 for i:=0 to 255 do
   Gen1[i].s:=sNone;
 Gen1ONSet:=[];
 Gen1NoUNKSet:=[];
 Gen0Set:=[];
 n1ON:=0;
 n1OFF:=0;
 n0:=0;
 with Form1.pole do
   begin Col:=21;Row:=21 end;
 for i:=0 to 41 do
 for j:=0 to 41 do
   a[i,j]:=sNone;
 with Form1 do begin
  Label1.Caption:=IntToStr(n1ON);
  Label2.Caption:=IntToStr(n1OFF);
  Label3.Caption:=IntToStr(n1ON+n1OFF);
  Label4.Caption:=IntToStr(n0);
  ClearArrays;
  Label9.Caption := ' ';
  Label12.Caption := ' ';
 end;
end;


function MinNoneState: integer;
var i: integer;
begin
Result:=-1;
for i:=0 to 255 do
 if not (i in Gen0Set) then begin
  Result:=i;
  break;
 end;
if (Result<0) and not WasWarning then
  begin
    ShowMessage('More than 256 cells in gen 0');
    WasWarning := True;
  end;
end;

procedure incokr1(num: TCellNumbers);
var inum: TCellNumbers;
    i,m,k: integer;
    xx,xm,xp,yy,ym,yp:longint;
begin
  with Gen1[num] do
    begin xm:=x-1;xp:=x+1;ym:=y-1;yp:=y+1 end;
  m:=0;
  for inum:=0 to 255 do
   if inum in Gen0Set then with Gen1[inum] do
    if (x>=xm)and(x<=xp)and(y>=ym)and(y<=yp)and(inum<>num)
      then begin
             inc(m);
             okri[m]:=inum;
             inc(b);
             if m=8 then break;
           end;
  mo := m;
  inc(m);
  okri[m] := num;
  WasWarning := False;
  for xx:=xm to xp do
  for yy:=ym to yp do
  begin
    if (xx=Gen1[num].x) and (yy=Gen1[num].y) then continue;
    i:=mo;
    while i<>0 do with Gen1[okri[i]] do
        if (xx=x) and (yy=y) then break else dec(i);
    if i = 0 then
    begin
      k := MinNoneState;
      if k >= 0 then
      begin
        Gen1[k].x := xx;
        Gen1[k].y := yy;
        Gen1[k].s := sUnk;
        Gen1[k].b := 1;
        inc(n0);
        inc(m);
        okri[m] := k;
        exclude(Gen1ONSet,k);
        exclude(Gen1NoUNKSet,k);
        include(Gen0Set,k);
        a[xx,yy] := sUnk;
      end;
    end;
  end;
end;

procedure UpdateArray(num: TCellNumbers);
var
  i, k, nbrs, nbrso, pm: Integer;
  PriorSet, NextSet: TGenSet;
begin
  ParentsCount := 0;
  AltCount := 0;
  pm := 0;
  while ReadPrior0Set(PriorSet) do
  begin
    nbrso := 0;
    for k := 1 to mo do
      if (okri[k] in PriorSet) and (okri[k] <> num) then inc(nbrso);
    for I := 0 to ($1FF shr mo) do
    begin
      NextSet := PriorSet;
      nbrs := nbrso;
      for k := mo + 1 to 9 do
        if odd(I shr (k-mo-1)) then
        begin
          Include(NextSet, okri[k]);
          if okri[k] <> num then inc(nbrs);
        end;
      if (not (num in NextSet) and (nbrs in BRule) and (num in Gen1ONSet))
        or ((num in NextSet) and (nbrs in SRule) and (num in Gen1ONSet))
        or (not (num in NextSet) and not (nbrs in BRule) and not (num in Gen1ONSet))
        or ((num in NextSet) and not (nbrs in SRule) and not (num in Gen1ONSet))
      then
      begin
        WriteNext0Set(NextSet);
        inc(ParentsCount);
      end
      else
      begin
        WriteAlt0Set(NextSet);
        inc(AltCount);
      end;
    end;
    inc(pm);
    if pm >= 10000 then
    begin
      Form1.Label9.Caption := IntToStr(ParentsCount);
      Application.ProcessMessages;
      pm := 0;
    end
  end;
end;

procedure decokr1(num:TCellNumbers);
var inum  : TCellNumbers;
    m : byte;
    xm,xp,ym,yp:longint;
begin
  with Gen1[num] do
    begin xm:=x-1;xp:=x+1;ym:=y-1;yp:=y+1 end;
  m:=0;
  for inum:=0 to 255 do
   if inum in Gen0Set then with Gen1[inum] do
    if (x>=xm)and(x<=xp)and(y>=ym)and(y<=yp)
      then begin
             inc(m);
             okri[m]:=inum;
             if inum<>num then dec(b);
             if m=9 then break;
           end;
  for m:=1 to 9 do
   if (Gen1[okri[m]].b=0) and (Gen1[okri[m]].s=sUnk) then begin
      Gen1[okri[m]].s:=sNone;
      dec(n0);
      exclude(Gen0Set,okri[m]);
      a[Gen1[okri[m]].x,Gen1[okri[m]].y]:=sNone;
   end;
end;

procedure Gen0okr(num:TCellNumbers);
var inum  : TCellNumbers;
    m, i, j, k, b : integer;
    xm,xp,ym,yp:longint;
begin
  with Gen1[num] do
    begin xm:=x-1;xp:=x+1;ym:=y-1;yp:=y+1 end;
  m:=0;
  OkrSet:=[];
  for inum:=0 to 255 do
   if inum in Gen0Set then with Gen1[inum] do
    if (x>=xm)and(x<=xp)and(y>=ym)and(y<=yp)and(inum<>num)
      then begin
             inc(m);
             okri[m]:=inum;
             include(OkrSet,inum);
             if m=8 then break;
           end;
  include(OkrSet,num);
  Okr0Count:=0;
  for i:=0 to 511 do begin
   j:=i;
   b:=0;
   for k:=1 to 8 do begin
    if odd(j) then inc(b);
    j:=j shr 1;
   end;
   if ((Gen1[num].s=sON) and (not odd(j)) and (b in BRule)) or
      ((Gen1[num].s=sON) and odd(j) and (b in SRule)) or
      ((Gen1[num].s=sOFF) and (not odd(j)) and (not (b in BRule))) or
      ((Gen1[num].s=sOFF) and odd(j) and (not (b in SRule))) then begin
        j:=i;
        Okr0Vars[Okr0Count]:=[];
        for k:=1 to 8 do begin
         if odd(j) then include(Okr0Vars[Okr0Count],okri[k]);
         j:=j shr 1;
        end;
        if odd(j) then include(Okr0Vars[Okr0Count],num);
        Okr0Count := Okr0Count+1;
   end;
  end;
end;

procedure CorrCol1(sodx,sody:longint; State:TState);
var  i: integer;
     found, NeedInc: boolean;
begin
  found:=false;
  for i:=0 to 255 do
    if (i in Gen0Set) and (sodx=Gen1[i].x) and (sody=Gen1[i].y) then
    begin
      if Gen1[i].s=State then
      begin
         Gen1[i].s:=sUnk;
         exclude(Gen1ONSet,i);
         exclude(Gen1NoUNKSet,i);
         a[sodx,sody]:=sUNK;
         Form1.Pole.Repaint;
         if State=sON then dec(n1ON) else dec(n1OFF);
         decokr1(i);
         ParentsCount := StrToInt(Form1.Label12.Caption);
         SwapArrays(True);
         Form1.SetRecommendedColor(sUNK);
      end
      else
      begin
         NeedInc := False;
         case Gen1[i].s of
          sON: dec(n1ON);
          sOFF: dec(n1OFF);
         else NeedInc := True;
         end;
         if State=sON then inc(n1ON) else inc(n1OFF);
         Gen1[i].s:=State;
         if State=sON then include(Gen1ONSet,i) else exclude(Gen1ONSet,i);
         include(Gen1NoUNKSet,i);
         a[sodx,sody]:=State;
         Form1.Pole.Repaint;
         if NeedInc then
         begin
           incokr1(i);
           Form1.Label12.Caption := Form1.Label9.Caption;
           SwapArrays(True);
           inc(mo);
           UpdateArray(i);
         end
         else
         begin
           Form1.Label9.Caption := IntToStr(AltCount);
           AltCount := ParentsCount;
           ParentsCount := StrToInt(Form1.Label9.Caption);
           SwapArrays(False);
         end;
         
         Form1.SetRecommendedColor(State);
      end;
      found:=true;
      break;
    end;
  if not found then
  begin
    i:=MinNoneState;
    if i>=0 then
    begin
      Gen1[i].x := sodx;
      Gen1[i].y := sody;
      Gen1[i].s:=State;
      Gen1[i].b:=0;
      inc(n0);
      if State=sON then inc(n1ON) else inc(n1OFF);
      if State=sON then include(Gen1ONSet,i);
      include(Gen1NoUNKSet,i);
      include(Gen0Set,i);
      a[sodx,sody]:=State;
      Form1.Pole.Repaint;
      incokr1(i);
      Form1.Label12.Caption := Form1.Label9.Caption;
      SwapArrays(True);
      UpdateArray(i);
      Form1.SetRecommendedColor(State);
    end;
  end;
end;

procedure Recalc0Set(nadd: integer);
begin

end;


procedure TForm1.PoleDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
begin
 with pole,Canvas,Brush do begin
  Color:=StateColors[a[acol,arow]];
  FillRect(rect);
 end
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  I: Integer;
begin
  LogFileName := ChangeFileExt(Application.ExeName, '.log');
  ReadIni;
  for I := 0 to 195 do
    MinParents[I] := -1;
  Randomize;
  ClrCol;
end;

procedure TForm1.ReadIni;
var
  IniFile: TIniFile;
  Exponent: Integer;
begin
  IniFile := TIniFile.Create(ChangeFileExt(Application.ExeName, '.ini'));
{  ParentsCountLimit := IniFile.ReadInteger('Limits', 'ParentsCountLimit', 0);
  if ParentsCountLimit = 0 then
  begin
    Exponent := IniFile.ReadInteger('Limits', 'ParentsCountLimitExponent', 0);
    if Exponent <> 0 then ParentsCountLimit := 1 shl Exponent;
  end;
  if ParentsCountLimit = 0 then
  begin
    LimFactor := IniFile.ReadFloat('Limits', 'LimFactor', 0);
    LimAddMember := IniFile.ReadInteger('Limits', 'LimAddMember', 0);
    for I := 0 to 195 do
      MinParents[I] := -1;
  end;                             }
  Exponent := IniFile.ReadInteger('Limits', 'DiskBufferExponent', 9);
  DiskBuffer := 1 shl Exponent;
  MemoryBuffer := IniFile.ReadInteger('Limits', 'MemoryBuffer', 0);
  if MemoryBuffer = 0 then
  begin
    Exponent := IniFile.ReadInteger('Limits', 'MemoryBufferExponent', 0);
    if Exponent <> 0 then MemoryBuffer := 1 shl Exponent;
  end;
  IniFile.Free;
end;

procedure TForm1.PoleMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var aCol,aRow : integer;
    GridRect  : TGridRect;
begin
  pole.MouseToCell(X,Y,aCol,aRow);
  GridRect.Left := acol;
  GridRect.Top := arow;
  GridRect.Right := acol;
  GridRect.Bottom := arow;
  Pole.Selection := GridRect;
  Pole.Enabled := False;
  if Button=mbRight then
   CorrCol1(acol,arow,sOFF)
  else if Button=mbLeft then
   CorrCol1(acol,arow,sON);
  Pole.Enabled := True;
  Pole.Repaint;
  Label1.Caption:=IntToStr(n1ON);
  Label2.Caption:=IntToStr(n1OFF);
  Label3.Caption:=IntToStr(n1ON+n1OFF);
  Label4.Caption:=IntToStr(n0);
  Label9.Caption := IntToStr(ParentsCount);
  if cbAutoCorr.Checked then Timer1.Enabled := True;
end;

procedure TForm1.btClearClick(Sender: TObject);
begin
 ClrCol;
 pole.Refresh;
end;

procedure TForm1.SetRecommendedColor(State: TState);
var
  I: Integer;
  AverageValue, ONReduction, ONRedLimit: Int64;
begin
  if Label12.Caption = ' ' then AverageValue := 1 else AverageValue := StrToInt(Label12.Caption);
  for I := 1 to (9 - mo) do AverageValue := AverageValue * 2;
  ONReduction := AverageValue - ParentsCount - ParentsCount;
  If State = sOFF then ONReduction := - ONReduction;
  if cbRandCorr.Checked
  then ONRedLimit := AverageValue * (seFrom.Value + Random(seOdds.Value - seFrom.Value)) div 100
  else ONRedLimit := AverageValue * seOdds.Value div 100;
  if (State = sUNK) then PaintBox1.Color := StateColors[sUNK]
  else
    if ONReduction >= ONRedLimit
    then PaintBox1.Color := StateColors[sON]
    else PaintBox1.Color := StateColors[sOFF];
  PaintBox1.Repaint;
end;

procedure TForm1.PaintBox1Paint(Sender: TObject);
begin
  with Sender as TPaintBox do
  begin
    Canvas.Brush.Color := Color;
    Canvas.FillRect(ClientRect);
  end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  State: TState;
begin
  (Sender as TTimer).Enabled:= False;
  State := a[Pole.Col, Pole.Row];
  if PaintBox1.Color <> StateColors[State]
  then
    if State = sON then CorrCol1(Pole.Col,Pole.Row,sOFF)
    else  if State = sOFF then CorrCol1(Pole.Col,Pole.Row,sON);
  Label1.Caption:=IntToStr(n1ON);
  Label2.Caption:=IntToStr(n1OFF);
  Label3.Caption:=IntToStr(n1ON+n1OFF);
  Label4.Caption:=IntToStr(n0);
  Label9.Caption := IntToStr(ParentsCount);
end;

procedure TForm1.btStartClick(Sender: TObject);
var
  I, ACol, ARow: Integer;
  GridRect  : TGridRect;
  State, State1: TState;
  DF: Integer;
  S: String;
  NeedLog: Boolean;
begin
  ClrCol;
  StopAutoCalc := False;
  for I := 0 to 195 do
  begin
    ACol := CellSequence[I,0];
    ARow := CellSequence[I,1];
    GridRect.Left := acol;
    GridRect.Top := arow;
    GridRect.Right := acol;
    GridRect.Bottom := arow;
    Pole.Selection := GridRect;
    Application.ProcessMessages;
    if Random(100) < seOdds.Value
    then State := sON
    else State := sOFF;
    CorrCol1(ACol, ARow, State);
    Pole.Repaint;
    Label1.Caption:=IntToStr(n1ON);
    Label2.Caption:=IntToStr(n1OFF);
    Label3.Caption:=IntToStr(n1ON+n1OFF);
    Label4.Caption:=IntToStr(n0);
    Label9.Caption := IntToStr(ParentsCount);
    Application.ProcessMessages;
    if cbAutoCorr.Checked then
    begin
      if PaintBox1.Color <> StateColors[State]
      then
        if State = sON then State1 :=sOFF
        else  if State = sOFF then State1 := sON else
      else State1 := State;
      if Random(100) < seBlunder.Value
      then
        if State1 = sON then State1 :=sOFF
        else  if State1 = sOFF then State1 := sON;
      if State1 <> State
      then CorrCol1(Pole.Col,Pole.Row,State1);
      Label1.Caption:=IntToStr(n1ON);
      Label2.Caption:=IntToStr(n1OFF);
      Label3.Caption:=IntToStr(n1ON+n1OFF);
      Label4.Caption:=IntToStr(n0);
      Label9.Caption := IntToStr(ParentsCount);
      Application.ProcessMessages;
    end;
    CurParents[I] := ParentsCount;
    NeedLog := ParentsCount=0;
    if (ParentsCount=0)
      or (  {  (ParentsCountLimit<>0) and(ParentsCount>=ParentsCountLimit))
      or ((ParentsCountLimit=0)
         and  } ((LimFactor<>0) or (LimAddMember<>0))
         and (MinParents[I] >= 0)
         and (ParentsCount > (Round(MinParents[I]*LimFactor) + LimAddMember)))
    then break;
    NeedLog := NeedLog or (I=195);
    if StopAutoCalc then exit;
  end;
  if NeedLog then
  begin
    if not FileExists(LogFileName) then FileClose(FileCreate(LogFileName));
    DF := FileOpen(LogFileName, fmOpenWrite);
    FileSeek(DF, 0, 2);
    S := LogString;
    FileWrite(DF, S[1], Length(S));
    FileClose(DF);
    if { (ParentsCountLimit=0) and } ((LimFactor<>0) or (LimAddMember<>0)) then
      for I := 0 to 195 do
      begin
        if (CurParents[I] < MinParents[I]) or (MinParents[I] < 0)
        then MinParents[I] := CurParents[I];
        if CurParents[I] = 0 then break;
      end;
  end;
  if cbAutoCalc.Checked then Timer2.Enabled := True;
end;

procedure TForm1.seFromExit(Sender: TObject);
begin
  if seFrom.Value > seOdds.Value then seOdds.Value := seFrom.Value;
end;

procedure TForm1.seOddsExit(Sender: TObject);
begin
  if seFrom.Value > seOdds.Value then seFrom.Value := seOdds.Value;
end;

function TForm1.LogString: String;
var
  I, J: Integer;
  B: Byte;
  S: String;
begin
  S := DateTimeToStr(Now);
  if cbAutoCorr.Checked then S := S + ' A' else S := S + '  ';
  if cbRandCorr.Checked then S := S + 'R' else S := S + ' ';
  S := S + ' ' + IntToStr(seFrom.Value) + ' ' + IntToStr(seOdds.Value);
  S := S + ' ' + IntToStr(n1ON + n1OFF);
  S := S + ' ' + IntToStr(ParentsCount);
  S := S + ' ';
  for I := 0 to 48 do
  begin
    B := 0;
    for J := 0 to 3 do
      if (4*I+J) in Gen1ONSet then B := B or ($01 shl J);
    S := S + HexaCode[B];
  end;
  S := S + #13#10;
  Result := S;
end;

procedure TForm1.Timer2Timer(Sender: TObject);
begin
Timer2.Enabled := False;
if not StopAutoCalc then btStartClick(Self);
end;

procedure TForm1.cbRandCorrClick(Sender: TObject);
begin
  Label14.Visible := cbRandCorr.Checked;
  Label15.Visible := cbRandCorr.Checked;
  seFrom.Visible := cbRandCorr.Checked;
end;

procedure TForm1.edAddMemberKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in [#8, '0'..'9']) then Key := #0;
end;

procedure TForm1.edFactorKeyPress(Sender: TObject; var Key: Char);
begin
  if not (Key in [#8, '0'..'9', DecimalSeparator])
  or
  ((Key = DecimalSeparator) and  (Pos(DecimalSeparator, TEdit(Sender).Text) > 0))
  then Key := #0;
end;

procedure TForm1.edFactorExit(Sender: TObject);
begin
try
  LimFactor := StrToFloat((Sender as TEdit).Text);
except
  on EConvertError do
  begin
    (Sender as TEdit).Text := '0';
    LimFactor := 0;
  end;
end;
end;

procedure TForm1.edAddMemberExit(Sender: TObject);
begin
try
  LimAddMember := StrToInt((Sender as TEdit).Text);
except
  on EConvertError do
  begin
    (Sender as TEdit).Text := '0';
    LimAddMember := 0;
  end;
end;
end;

end.
